<?php
/******************************************************************************/
//                               © lokanaft                                   //
/******************************************************************************/

class p_root_path extends cmsPlugin {

// ==================================================================== //

    public function __construct(){

        parent::__construct();

        $this->info['plugin']           = 'p_root_path';
        $this->info['title']            = 'Root Path';
        $this->info['description']      = 'Позволяет открываться компонентам из корневого каталога без префикса';
        $this->info['author']           = '<a href="http://www.instantcms.ru/users/lokanaft#upr_p_services">lokanaft</a>';
        $this->info['version']          = '0.1b';

        $this->config['Components']     = 'users';

        $this->events[] = 'BEFORE_COMPONENT_CONTENT';
        
        if(!isset($this->inCore))$this->inCore = cmsCore::getInstance();
        $this->uri = trim(str_replace('   content', '', '   '.$this->inCore->uri));

    }

// ==================================================================== //

    public function execute($event, $item){

        parent::execute();

        switch ($event){
            case 'BEFORE_COMPONENT_CONTENT': return $this->eventMain();
        }
        return $item;
    }

// ==================================================================== //

    private function eventMain() {
        
        flush();

        $components = explode(',', $this->config['Components']);
        
        foreach($components as $component){
            if($this->proceedBody($component))
                return true;
        }
        $this->inCore->uri = 'content'.$this->uri;
        $this->inCore->component = 'content'; 
        return false;

    }

// ==================================================================== //
    
    private function proceedBody($component){
        
        //$component = $this->component;                                        //убрано

        //проверяем что компонент указан
        if (!$component) { return false; }
        
        $this->inCore->component = $component;                                  //изменено

        // компонент включен?
        if(!$this->inCore->isComponentEnable($component))return false;          //изменено

        cmsCore::loadLanguage('components/'.$component);

        $this->inCore->uri = $component.$this->uri;                             //добавлено
        //парсим адрес и заполняем массив $_REQUEST
        if(!$this->inCore->parseComponentRoute()){                              //изменено
            //die('parseComponentRoute');                                       //
            return false;                                                       //
        }                                                                       //
        // узнаем действие в компоненте
        $this->inCore->detectAction();                                          //изменено

        ob_start();

        // Вызываем сначала плагин (если он есть) на действие
        // Успешность выполнения должна определяться в методе execute плагина
        // Он должен вернуть true
        if(!cmsCore::callEvent(mb_strtoupper('get_'.$component.'_action_'.$this->inCore->do), false)){//изменено
            if(!function_exists($component))
                require('components/'.$component.'/frontend.php');

            if(call_user_func($component) === false){ob_end_clean();$this->inCore->uri = str_replace('   '.$component, '', '   '.$this->inCore->uri);return false;}//изменено

        }

        cmsPage::getInstance()->page_body = cmsCore::callEvent('AFTER_COMPONENT_'.mb_strtoupper($component), ob_get_clean());

        return true;

    }

}

?>
